% [ file video_musing/README.m ]

s060215_musing_change_detection;


% Implement processing of the video

for cam = 1:3
  
  par = [];
  par.binary_mask = zeros( 288, 360 );
  par.binary_mask( 5:288, 6:356 ) = 1;
  par.in_filename_template = sprintf( '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/ppm_cam%d/image*.ppm', cam );
  par.in_filename_regexp = 'image(\d+).ppm';
  
  a_dir = '/home/speech/lathoud/2005-10-11-MMM-BACKUP/Lathoud/av16.3_v6';
  addpath( a_dir );
  o = seq_av163( 'seq11-1p-0100', a_dir );
  
  par.frame1_timestamp = o.cam(1).frame1_timestamp;

  par.interval_sec = 1 / 25;

  par.resolution = [ 24 32 ];

  par.out_filename = sprintf( '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/seq11-1p-0100_cam%d_video_motion_%02d_%02d.mat', cam, par.resolution );

  s060222_extract_motion( par );

end

% 2006-02-23
% Look at the result

load /home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/seq11-1p-0100_cam3_video_motion_24_32.mat

a_min = min( video_motion.mat(:) );
a_max = max( video_motion.mat(:) );

figure( 1 ); clf; hold off;

for a = 1:numel( video_motion.timestamp_sec )
  
  figure( 1 ); imagesc( video_motion.mat( :,:,a ), [ a_min, a_max ] ); colorbar;
  title( video_motion.timestamp_sec( a ) );
  
  pause( 0.03 );
  
end

% -> not bad at all
% -> still some type of memory would even improve things
%    when there is no motion.
%    (forgetting factor, as for USS)

% 2006-02-23
% Extract sector-based audio activity features

a_dir = '/home/speech/lathoud/2005-10-11-MMM-BACKUP/Lathoud/av16.3_v6/session09/seq11-1p-0100/16kHz';

wavefilename_template   = fullfile( a_dir, 'seq11-1p-0100_array1_mic*.wav' );
ssm_parameters_filename = 'DATA/ssm_parameters_512_16000_342-pointset_np80.mat';

ssm_result = extract_ssm_fast( wavefilename_template, ssm_parameters_filename );

save( '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/seq11-1p-0100_array1_ssm_result.mat', 'ssm_result' );

% Fit a model on it

s060223_fit_audio_model( '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/seq11-1p-0100_array1_ssm_result.mat' );


% 2006-02-23
% Do some cross-correlation analysis

a_dir = '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100';

video_filename_list = { fullfile( a_dir, 'seq11-1p-0100_cam1_video_motion_24_32.mat' ), fullfile( a_dir, 'seq11-1p-0100_cam2_video_motion_24_32.mat' ), fullfile( a_dir, 'seq11-1p-0100_cam3_video_motion_24_32.mat' ) };

audio_filename = fullfile( a_dir, 'seq11-1p-0100_array1_ssm_result.mat' );

audio_start_time = 10.0;

s060223_cc_analysis( video_filename_list, audio_filename, audio_start_time );

save( fullfile( a_dir, 'cc_result.mat', 'cc_result' ) );



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2006-02-23
% Trying again, with "product" feature instead

% Implement processing of the video

for cam = 1:3

  par = [];
  par.binary_mask = zeros( 288, 360 );
  par.binary_mask( 5:288, 6:356 ) = 1;
  par.in_filename_template = sprintf( '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/ppm_cam%d/image*.ppm', cam );
  par.in_filename_regexp = 'image(\d+).ppm';

  a_dir = '/home/speech/lathoud/2005-10-11-MMM-BACKUP/Lathoud/av16.3_v6';
  addpath( a_dir );
  o = seq_av163( 'seq11-1p-0100', a_dir );

  par.frame1_timestamp = o.cam(1).frame1_timestamp;

  par.interval_sec = 1 / 25;

  par.resolution = [ 24 32 ];

  par.out_filename = sprintf( '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/seq11-1p-0100_cam%d_video_motion2_%02d_%02d.mat', cam, par.resolution );

  s060223_extract_motion2( par );

end


% 2006-03-06
% Look at the two types of results

which_one = 1;

switch which_one
  case 1
   load /home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/seq11-1p-0100_cam3_video_motion_24_32.mat
 case 2
  load /home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/seq11-1p-0100_cam3_video_motion2_24_32.mat
end

a_min = min( video_motion.mat(:) );
a_max = max( video_motion.mat(:) );

figure( which_one ); clf; hold off;

for a = 1:6:numel( video_motion.timestamp_sec )

  figure( which_one ); imagesc( video_motion.mat( :,:,a ), [ a_min, a_max ] ); colorbar;
  title( video_motion.timestamp_sec( a ) );

  pause( 0.03 );

end

% -> very similar overall,
% -> only visible difference BEFORE Iain appears: the "motion2" is much less noisy than "motion"
%    (AND instead of OR)
% -> we'll use motion2


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2006-03-07
% Ok now that we have decided on the video features,
% let's:
% ( 1 ) Launch it on the other selected sequences of AV16.3.
% ( 2 ) Run the cross-correlation analysis.



% ( 1 ) Launch it on the other selected sequences of AV16.3.

basedir = '/home/speech/lathoud/FEATURES/avcalib';
recording_list = { 'seq11-1p-0100', 'seq15-1p-0100', 'seq18-2p-0101', 'seq24-2p-0111', 'seq40-3p-0111', 'seq45-3p-1111' };

s060307_extract_video( basedir, recording_list );

s060307_extract_audio( basedir, recording_list );

% ( 2 ) Run the cross-correlation analysis

basedir = '/home/speech/lathoud/FEATURES/avcalib';
recording_list = { 'seq11-1p-0100', 'seq15-1p-0100', 'seq18-2p-0101', 'seq24-2p-0111', 'seq40-3p-0111', 'seq45-3p-1111' };

s060307_run_cc_analysis( basedir, recording_list );


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2006-03-09
% Look at the results of the cross-correlation analysis

basedir = '/home/speech/lathoud/FEATURES/avcalib';
recording_list = { 'seq11-1p-0100', 'seq15-1p-0100', 'seq18-2p-0101', 'seq24-2p-0111', 'seq40-3p-0111', 'seq45-3p-1111' };

for a = 1:numel( recording_list )
  
  s060309_look_at_cc_analysis( fullfile( basedir, recording_list{ a }, [ 's060307_run_cc_analysis-' recording_list{ a } '.mat' ] ) );

end

% -> av: working fine on seq11.
%                a bit on seq15.
%                quite bad on others seq (multispeaker).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2006-03-09
% Run cross-correlation analysis, weighting frames
% with audio speech frame posterior.

basedir = '/home/speech/lathoud/FEATURES/avcalib';
recording_list = { 'seq11-1p-0100', 'seq15-1p-0100', 'seq18-2p-0101', 'seq24-2p-0111', 'seq40-3p-0111', 'seq45-3p-1111' };

s060309_run_cc_analysis_weight( basedir, recording_list );


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2006-03-13
% Added storage of the raw covariance matrix
% to the "s060307_run_cc_analysis.m" version,
% and relaunched it on seq11

% -> finally: cov_mat brings the most usable results.
% -> with speech/silence weighting, slightly less noise.


load /home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/s060309_run_cc_analysis_weight-seq11-1p-0100.mat

for a=1:3
  [tmp,ind] = max( cc_result.list( a ).cov_mat, [], 3 );
  figure; imagesc( tmp ); colorbar;
  figure; imagesc( ind ); colorbar;
end

for a=1:3
  [tmp,ind] = max( cc_result.list( a ).cov_mat, [], 3 );
  mask = tmp > exp( -6 );
  figure; imagesc( tmp .* mask ); colorbar;
  figure; imagesc( ind .* mask ); colorbar;
end


for a = 1:18
  
  tmp = cc_result.list( 3 ).cov_mat( :,:,a );
  mask = tmp > exp(-6);
  figure( a ); clf; imagesc( tmp .* mask ); colorbar
  title( a );
    
end

%%%%%%%%%%%%%%%%%%%%
% Black and white

s060831_show_cc_result_color_bw;

% For just one sector

s060920_show_one_cc_result_color_bw;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2006-03-13
%
% Alternative:
%
% Maybe use results of detection-localization,
% the simplest may be to just compute the weighted
% mean and std dev azimuth angle, for each pixel.
%
% Or at least a histogram (e.g. 360 bins) for each pixel
% Then fit a G+U on the histogram.
% Watch out to find the center.

>> 360*360*288*4

ans =

   149299200

% -> uint32


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2006-04-27
% Extract some pictures for the report
% store the data necessary to show the pictures

load /home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/s060309_run_cc_analysis_weight-seq11-1p-0100.mat

clear cam;

for a=1:3
  [cc_max,cc_max_ind] = max( cc_result.list( a ).cov_mat, [], 3 );
  cam( a ).cc_max = cc_max;
  cam( a ).cc_max_ind = cc_max_ind;
end

save s060427_cc_max_weighted.mat cam


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2006-07-17
% Implementing Stauffer's GMM method for 
% adaptive background subtraction (IEEE PAMI august 2000)
%
% This setup seems to work okay on all three cameras:
%   alpha = 0.01
%   T = 0.66
%   K = 3     (walls, chairs and laptops, people)

for a = 2:3

  ppmcam_str = sprintf( 'ppm_cam%d', a );
  
  input_template  = [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/' ppmcam_str '/image*.ppm' ];
  output_namehead = [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/OUTPUT/' ppmcam_str '_classif_' ];
  % Mask to remove the digital information that is flickering on the image borders
  clear p
  p.mask = zeros( 288, 360, 3 );
  p.mask( 4:288, 6:356, : ) = 1;
  
  % Launch adaptive bg subtraction
  p.alpha = 1e-2;
  p.T     = 0.66;
  output_namehead = [ output_namehead sprintf( 'alpha%g_T%g_', p.alpha, p.T ) ];
  s060717_bgsubgmm( input_template, output_namehead, p );
  
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2006-07-19
% Run the detection-localization on the second array

FAST_detect_locate_wrapper_array2( 'seq11-1p-0100' );

% Run the SNS modelling

par = [];
par.in_filename = 'DATA/FAST_detect_locate_wrapper_array2-seq11-1p-0100-result.mat';
par.n_comp_list = 2:10;

% To select the automatic threshold for the final decision,
% based on IDIAP RR 05-52. This is a False Alarm Rate target, between 0 and 1.
%
% NOTE: the threshold is less conservative than above, in order to
% counterbalance the fact that we now use BOTH wideband activeness and
% MFCC vectors to discriminate between speech and non-speech.
par.far_t = 0.01;

par.out_dir     = 'DATA';

sbmfcc_sns_model( par );   % This one takes time

% Keep speech location estimates only

classify_cluster_sns( 'DATA/sbmfcc_sns_model-FAST_detect_locate_wrapper_array2-seq11-1p-0100-result.mat' );


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2006-07-19
% Try to improve the video bg sub on one camera,
% using one array.
%
% For the original video bg sub, 
% we use the K = 3, alpha = 0.01, T = 0.66.

for a = 1:3
  
  ppmcam_str = sprintf( 'ppm_cam%d', a );
  
  clear p
  
  p.input_template         = [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/' ppmcam_str '/image*.ppm' ];
  p.videoframerate         = 25;
  p.input_timecodefile     = [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/' ppmcam_str '/TIMECODES' ];
  p.input_classif_namehead = sprintf( [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/OUTPUT/' ppmcam_str '_classif_%f_' ], 0.01 );
  
  a_name                   = 'classify_cluster_sns-sbmfcc_sns_model-FAST_detect_locate_wrapper_array1-seq11-1p-0100-result.mat'
  p.input_arrayfile        = [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/OUTPUT/' a_name ];
  p.audiostart_videotime   = 10.0;  % in seconds
  
  p.a_alpha = 1e-2;
  p.v_alpha = 1e-2;
  a_str = [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/OUTPUT/' ppmcam_str '_classif2_a_alpha%g_v_alpha%g_' ];
  p.output_namehead        = sprintf( a_str, p.a_alpha, p.v_alpha );
  
  % Mask to remove the digital information that is flickering on the image borders
  p.mask = zeros( 288, 360, 3 );
  p.mask( 4:288, 6:356, : ) = 1;
  
  % Launch adaptive AV modelling + improved bg subtraction
  
  s060719_onearray_onecam_bgsubgmm( p );
  
end

s060720_look_at_first_av_results;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2006-07-20
% Great. Now try with two arrays.
% Also write out the speech pixels (values = nb of array: 0 array -> 0, 1 array -> 127, 2 arrays -> 255 )

% we use the K = 3, alpha = 0.01, T = 0.66.

for a = 1:3

  ppmcam_str = sprintf( 'ppm_cam%d', a );

  clear p

  p.input_template         = [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/' ppmcam_str '/image*.ppm' ];
  p.videoframerate         = 25;
  p.input_timecodefile     = [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/' ppmcam_str '/TIMECODES' ];
  p.input_classif_namehead = sprintf( [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/OUTPUT/' ppmcam_str '_classif_%f_' ], 0.01 );

  a_name                   = 'classify_cluster_sns-sbmfcc_sns_model-FAST_detect_locate_wrapper_array1-seq11-1p-0100-result.mat'
  p.input_arrayfile_list{ 1 }   = [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/OUTPUT/' a_name ];
  a_name                   = 'classify_cluster_sns-sbmfcc_sns_model-FAST_detect_locate_wrapper_array2-seq11-1p-0100-result.mat'
  p.input_arrayfile_list{ 2 }   = [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/OUTPUT/' a_name ];
  p.audiostart_videotime   = [ 10.0 10.0 ];  % in seconds

  p.a_alpha = 1e-2;
  p.v_alpha = 1e-2;
  a_str = [ '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/OUTPUT/' ppmcam_str '_classif2_twoarrays_a_alpha%g_v_alpha%g_' ];
  p.output_namehead        = sprintf( a_str, p.a_alpha, p.v_alpha );

  % Mask to remove the digital information that is flickering on the image borders
  p.mask = zeros( 288, 360, 3 );
  p.mask( 4:288, 6:356, : ) = 1;

  % Launch adaptive AV modelling + improved bg subtraction

  s060720_twoarrays_onecam_bgsubgmm( p );

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Show some figures 


s060720_look_at_first_av_results_gray;

% xxxxxxxxxx