function s060307_extract_audio( basedir, recording_list )
  
  if nargin < 2
    error( [ mfilename ' needs 2 input argument.' ] );
  end

  n_rec = numel( recording_list );

  for a = 1:n_rec
    
    % Process the audio recording
    
    recording_name = recording_list{ a };

    out_filename = sprintf( '/home/speech/lathoud/FEATURES/avcalib/%s/%s_array1_ssm_result.mat', recording_name, recording_name );
    
    if exist( out_filename, 'file' )
      
      disp( [ mfilename ': output file already exists. Skipping it.' ] );
      disp( [ '  "' out_filename '"' ] );

    else
      
      disp( [ mfilename ': starting processing a video. The output file will be:' ] );
      disp( [ '  "' out_filename '"' ] );
      
      % Create it to lock it from other computers
      
      fid = fopen( out_filename, 'wt' );
      fclose( fid );
      
      % Do the processing
      
      a_dir = sprintf( '/home/speech/lathoud/2005-10-11-MMM-BACKUP/Lathoud/av16.3_v6/%s/16kHz', recording_name );
      
      wavefilename_template   = fullfile( a_dir, [ recording_name '_array1_mic*.wav' ] );
      ssm_parameters_filename = 'DATA/ssm_parameters_512_16000_342-pointset_np80.mat';
      
      ssm_result = extract_ssm_fast( wavefilename_template, ssm_parameters_filename );
      
      save( out_filename, 'ssm_result' );
      
    end
    
  end % Loop through audio recordings
  