function s060920_look_at_one_example_gray

fig_count = 1;

  for a = 1:3


    a_dir = '/home/speech/lathoud/FEATURES/avcalib/seq11-1p-0100/OUTPUT/';
    a_name = sprintf( 'ppm_cam%d_classif2_a_alpha0.01_v_alpha0.01__s060719_onearray_onecam_bgsubgmm_last_models.mat', a );

    load( fullfile( a_dir, a_name ), 'av_model' );
    
    p = av_model.par;
    
    [ tmp, sort_ind ] = sort( -av_model.w ./ ( eps + sqrt( max( 0, prod( av_model.sigma, 3 ) ) ) ), 4 );
    
    ind1 = repmat( (1:av_model.im_size(1)).', [ 1 av_model.im_size(2) 1 p.a_K ] );
    ind2 = repmat( (1:av_model.im_size(2)),  [ av_model.im_size(1) 1 1 p.a_K ] );
    ind3 = repmat( permute( ( 1 ).', [ 3 2 1 ] ), [ av_model.im_size(1:2) 1 p.a_K ] );
    ind4 = sort_ind;
    
    w_ind = sub2ind( size( av_model.w ), ind1, ind2, ind3, ind4 );
    
    B = sum( cumsum( cat( 4, zeros( [ av_model.im_size(1:2)  ] ), av_model.w( w_ind ) ), 4 ) < p.a_T, 4 );
    
    B( find( all( av_model.w == 0, 4 ) ) ) = 0;
    
    % Show
    
    fac = 180 / pi;

    
    for b = 1:3
      hfig = figure( fig_count ); fig_count = fig_count + 1; 
      special_gray( av_model.mu( :,:,1,b ) * fac, 0, [-pi/2 0.75 * pi ] * fac );
      title( sprintf( '\\mu_%d ( cam %d )', b, a ) );
      out_filename = sprintf( 'DATA/one-array-av-model-cam-%d-mu-%d-bw.eps', a, b );
      print( hfig, '-deps2', out_filename );
      disp( [ mfilename ' wrote out "' out_filename '".' ] );
    end
    
    hfig = figure( fig_count ); fig_count = fig_count + 1; special_gray( B, 1 ); title( sprintf( 'B ( cam %d )', a ) );
    out_filename = sprintf( 'DATA/one-array-av-model-cam-%d-B-bw.eps', a );
    print( hfig, '-deps2', out_filename );
    disp( [ mfilename ' wrote out "' out_filename '".' ] );
    
    
  end
  
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Foreground: gray levels
% Background: white

function special_gray( im, is_int, YLim )

  if nargin < 2
    is_int = 0;
  end

  tmp = reshape( im( ~isnan( im ) ), [], 1 );
    
  if nargin < 3

    YLim = [ min( tmp ) max( tmp ) ];

  end
  
  im2 = im;
  
  im2( isnan( im2 ) ) = YLim( 1 );
  
  im2 = max( YLim(1), min( YLim(2), im2 ) );
  
  imagesc( im2 );

  set( gca, 'XTick', [], 'YTick', [] );
  set( gca, 'fontsize', 20 );

  ccm = colormap( 'gray' ); 
  ccm( 1, : ) = 0;
  
  n1 = numel( unique( tmp ) )
  n2 = size( ccm, 1 )
  
  if is_int
    ccm = repmat( ( 0:n1-1 ).' / (n1-1), 1, 3 );
  end
  
  colormap( ccm );
  h = colorbar; set( h, 'YLim', YLim, 'fontsize', 20 );
  
  if is_int

    set( h, 'YTick', ( 0.5 + (0:n1-1) ) / n1 * ( n1 - 1 ), 'YTickLabel', 0:n1-1 );
    
  end


