for a = 3:5

a_str = sprintf( 'TRN-%02d', a )

FAST_detect_locate_wrapper( [ 'Scripted-Meeting-' a_str '' ] );

% ( 2 ) Set an automatic threshold on posteriors of wideband activity

par = [];
par.in_filename = [ 'DATA/FAST_detect_locate_wrapper-Scripted-Meeting-' a_str '-result.mat' ];
par.n_comp_list = 2:10;

% To select the automatic threshold for the final decision,
% based on IDIAP RR 05-52. This is a False Alarm Rate target, between 0 and 1.
%
% NOTE: the threshold is less conservative than above, in order to
% counterbalance the fact that we now use BOTH wideband activeness and
% MFCC vectors to discriminate between speech and non-speech.
par.far_t = 0.01;

par.out_dir     = 'DATA';

sbmfcc_sns_model( par );   % This one takes time

% ( 3 ) Now use the threshold to take a cluster-level decision

classify_cluster_sns( [ 'DATA/sbmfcc_sns_model-FAST_detect_locate_wrapper-Scripted-Meeting-' a_str '-result.mat' ] );

% ( 4 ) Now run STATIC location clustering to determine automatically:
% - the number and positions of most occupied locations in the meeting.
% - the speech segments.

static_sigma( [ 'DATA/classify_cluster_sns-sbmfcc_sns_model-FAST_detect_locate_wrapper-Scripted-Meeting-' a_str '-result.mat' ] );

% ( 5 ) Show the resulting meeting segmentation

% Don't show the figure
% (a matlab file and a text file are also written)
show_static_seg( [ 'DATA/static_sigma-classify_cluster_sns-sbmfcc_sns_model-FAST_detect_locate_wrapper-Scripted-Meeting-' a_str '-result.mat' ] );

end
